//+------------------------------------------------------------------+
//|                                                Stochastic MA.mq4 |
//|                                   Copyright  2009, Lakshmi Inc. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Blue
#property indicator_level1 70
#property indicator_level2 30
#property indicator_maximum 100
#property indicator_minimum 0

extern int MA_Period=7;
int MA_Shift=0;
double ExtMapBuffer[];
extern int RSI_Period=12;
int RSI_Timeframe=0;
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
int    draw_begin;
   string short_name="RSI EMA (";
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexShift(0,MA_Shift);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(MA_Period<2) MA_Period=13;
   draw_begin=MA_Period-1;
//---- indicator short name
   IndicatorShortName(short_name+MA_Period+")"+"RSI Period("+RSI_Period+")");
   SetIndexDrawBegin(0,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double pr=2.0/(MA_Period+1);
   int    pos=Bars-2;
   if(ExtCountedBars>2) pos=Bars-ExtCountedBars-1;
//---- main calculation loop
   while(pos>=0)
     {
      if(pos==Bars-2) ExtMapBuffer[pos+1]=iRSI(Symbol(),RSI_Timeframe,RSI_Period,PRICE_CLOSE,pos+1);
      ExtMapBuffer[pos]=iRSI(Symbol(),RSI_Timeframe,RSI_Period,PRICE_CLOSE,pos)*pr+ExtMapBuffer[pos+1]*(1-pr);
 	   pos--;
 	  }
  }
//+------------------------------------------------------------------+


